<?php
/*********************************************
  Coppermine 1.4 Plugin - Easy RSS
  ********************************************
  Copyright (c) 2007 Brent Gerig

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Mod by Andiwe for PicLens 
  ********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$thisplugin->add_action('plugin_install','easyrss_install');
$thisplugin->add_action('plugin_configure','easyrss_configure');
$thisplugin->add_action('plugin_uninstall','easyrss_uninstall');
$thisplugin->add_action('plugin_cleanup','easyrss_cleanup');
$thisplugin->add_filter('page_meta','easyrss_header');
$thisplugin->add_filter('thumb_caption_regular', 'piclens_thumbView');
$thisplugin->add_filter('gallery_footer','easyrss_footer');

function easyrss_install() {
    global $CONFIG, $lang_plugin_easyrss_config;
    require ('plugins/Easy_RSS/include/init.inc.php');

    if($_POST['submit'] == $lang_plugin_easyrss_config['button_install']) {

        // delete previous plugin config options if necessary (just in case)
        cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name REGEXP '^plugin_easyrss_'");

        $title = "title";
        switch($_POST['title'])
        {
            case "caption":
                $title = "caption";
                break;
            case "title":
            default:
                $title = "title";
                break;
        }

	if(!isset($_POST['num']) || !is_numeric($_POST['num']))
	    $num = 20;
	else
	    $num = $_POST['num'];
	    
	$fullsizethumbs = 0;
  $fullsizepics = 0;    
	
	if(isset($_POST['thumbs'])) {
	    $fullsizethumbs = $_POST['thumbs'];
	    if(in_array("fullsizethumbs",$fullsizethumbs))
	        $fullsizethumbs = 1;
	}
	
	if(isset($_POST['pics'])) {
	    $fullsizepics = $_POST['pics'];
	    if(in_array("fullsizepics",$fullsizepics))
	        $fullsizepics = 1;
	}
	
			if(!isset($_POST['mvslnum']) || !is_numeric($_POST['mvslnum']))
	    $mvslnum = 5;
	else
	    $mvslnum = $_POST['mvslnum'];
	    
			if(!isset($_POST['logo']))
	    $logo = '';
	else
	    $logo = $_POST['logo'];
	
	$show_meta = 0;
	$show_rss = 0;
	$show_google = 0;
	$show_yahoo = 0;
  	
    if(isset($_POST['show'])) {
	    $show = $_POST['show'];
	    if(in_array("meta",$show))
	        //$show_meta = 1;
	        $show_meta = 0;
            if(in_array("rss",$show))
	        //$show_rss = 1;
	        $show_rss = 0;
	    if(in_array("google",$show))
	        //$show_google = 1;
	        $show_google = 0;
	    if(in_array("yahoo",$show))
	        //$show_yahoo = 1;
	        $show_yahoo = 0;
	}
	

        $sql = "INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value)"
                    ." VALUES"
                    ." ('plugin_easyrss_titlefield','$title')"
		    .",('plugin_easyrss_num','$num')"
		    .",('plugin_easyrss_mvslnum','$mvslnum')"
		    .",('plugin_easyrss_logo','$logo')"
		    .",('plugin_easyrss_fullsizethumbs','$fullsizethumbs')"
		    .",('plugin_easyrss_fullsizepics','$fullsizepics')"
		    .",('plugin_easyrss_showmeta','$show_meta')"
		    .",('plugin_easyrss_showrss','$show_rss')"
		    .",('plugin_easyrss_showgoogle','$show_google')"
		    .",('plugin_easyrss_showyahoo','$show_yahoo')";
        cpg_db_query($sql);

	if(!file_exists("rss.php"))
	    copy("plugins/Easy_RSS/rss.php","rss.php");

        return true;
    } else {
        return 1;
    }
}

function easyrss_configure() {
    global $lang_plugin_easyrss, $lang_plugin_easyrss_config;
    require ('plugins/Easy_RSS/include/init.inc.php');

    echo <<< EOT
    <!--{$lang_plugin_easyrss_config['question_title']}<br />-->
    <form action="{$_SERVER['REQUEST_URI']}" method="post">
        <input type="hidden" name="title" value="title" checked><!--{$lang_plugin_easyrss['label_title']}<br />-->
        <input type="hidden" name="title" value="caption"><!--{$lang_plugin_easyrss['label_caption']}<br /><br />-->
	{$lang_plugin_easyrss_config['question_num']}	<input type="text" name="num" size="3" value="20"><br />
	{$lang_plugin_easyrss_config['question_mvslnum']}	<input type="text" name="mvslnum" size="3" value="5"><br />
	{$lang_plugin_easyrss_config['question_logo']}<br />	
  <input type="text" name="logo" size="40" value=""><br />
	<!--<br /><br />{$lang_plugin_easyrss_config['question_show']}<br />-->
	<input type="checkbox" name="thumbs[]" value="fullsizethumbs" unchecked>{$lang_plugin_easyrss_config['fullsizethumbs']}<br />
	<input type="checkbox" name="pics[]" value="fullsizepics" unchecked>{$lang_plugin_easyrss_config['fullsizepics']}<br />
	
	
	<input type="hidden" name="show[]" value="meta" unchecked><!-- {$lang_plugin_easyrss_config['show_meta']}<br />-->
	<input type="hidden" name="show[]" value="rss" unchecked><!-- {$lang_plugin_easyrss_config['show_rss']}<br />-->
	<input type="hidden" name="show[]" value="google" unchecked><!-- {$lang_plugin_easyrss_config['show_google']}<br />-->
	<input type="hidden" name="show[]" value="yahoo" unchecked><!-- {$lang_plugin_easyrss_config['show_yahoo']}<br /><br />-->
        <input type="submit" name="submit" value="{$lang_plugin_easyrss_config['button_install']}" />
	<input type="button" name="cancel" onclick="window.location='pluginmgr.php';" value="{$lang_plugin_easyrss_config['button_cancel']}" />
    </form><br />
  <b><font color="red">{$lang_plugin_easyrss_config['install_note']}</font><br /></b>
  <b><font color="red">{$lang_plugin_easyrss_config['install_note2']}</font><br /></b>
EOT;
}

function easyrss_uninstall() {
    global $CONFIG;

    if (!isset($_POST['remove'])) return 1;

    if ($_POST['remove']) {
        cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name REGEXP '^plugin_easyrss_'");
        unlink("rss.php");
    }

    return true;
}

function easyrss_cleanup($action) {
    global $lang_plugin_customhome_config;
    require ('plugins/Easy_RSS/include/init.inc.php');

    if ($action === 1) {
        echo <<< EOT
    <form action="{$_SERVER['REQUEST_URI']}" method="post">
        <p>
            {$lang_plugin_easyrss_config['cleanup_question']}<br />
            <font color="red">{$lang_plugin_easyrss_config['cleanup_note']}</font>
        </p>
        <div style="margin:25;">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td><input type="radio" name="remove" value="1" /></td>
                <td>{$lang_plugin_easyrss_config['yes']}</td>
            </tr>
            <tr>
                <td><input type="radio" name="remove" checked="checked" value="0" /></td>
                <td>{$lang_plugin_easyrss_config['no']}</td>
            </tr>
        </table>
        </div>
        <br />
        <span>
           <input type="submit" name="submit" value="{$lang_plugin_easyrss_config['button_submit']}" />
            <input type="button" name="cancel" onClick="window.location='pluginmgr.php';" value="{$lang_plugin_easyrss_config['button_cancel']}" />
        </span>
    </form>
EOT;
    }
}

function easyrss_header() {
    global $CONFIG,$lang_plugin_easyrss;
    require ('plugins/Easy_RSS/include/init.inc.php');

//A/ so here is the Header for PicLens
    $add_header_info = "";
//    $add_header_info = "<!-- Step 1: Add a Photos RSS feed to this webpage. //-->";
    $add_header_info .= "\n<link id=\"gallery\" rel=\"alternate\" href=\"rss.php?album=".$_GET['album']."&amp;page=".$_GET['page']."&amp;imgpos=".$_GET['pos']."\" type=\"application/rss+xml\" title=\"Image Gallery\" />";
//    $add_header_info .= "\n<!-- Step 2: Include the PiclensLite JavaScript. //-->";
    $add_header_info .= "\n<script type=\"text/javascript\" src=\"http://lite.piclens.com/current/piclens_optimized.js\">";
    $add_header_info .= "</script>\n<style type=\"text/css\"> .mbf-item {display:none;} </style>".$otherHead;
    return $add_header_info;
    
//A/ All other Information will not be included since the Header-install-Option is not checked/visible
    
/*    if($CONFIG['plugin_easyrss_showmeta'] && 
                in_array($_SERVER[SCRIPT_NAME],array('index.php','thumbnails.php','displayimage.php'))) {
        global $CONFIG;
        $album=$_GET['album'];
        $cat=$_GET['cat'];

	if(isset($cat) && $cat < 10000)
	    return;

	$name = "";
	if(is_numeric($album)) {
	    $name = get_album_name($album);
	    $name = $CONFIG[gallery_name]. " - " . $name['title'];
	} else if(isset($cat) && $cat > 0) {
		if($cat<10000) {
		    $name = easyrss_get_cat_name($cat);
		    $name = $CONFIG[gallery_name]. " - " . $name['name'];
		} else {
		    $name = $CONFIG[gallery_name]. " - " . get_username($cat-10000);
		}
	} else
	    $name = $CONFIG[gallery_name];
    
        $html = '<link rel="alternate" type="application/rss+xml" ';
        $html .= 'title="'.$name.' - '.$lang_plugin_easyrss['last_additions'].'"';
        $html .= ' href="'.$CONFIG[ecards_more_pic_target].'rss.php';
        if($album)
            $html .= "?album=".$album;
        if($cat)
            if($cat > 10000)
    	    $html .= "?album=lastupby&uid=".($cat-10000);
    	else
                $html .= "?cat=".$cat;
        $html .="\" />";

        return $html;
    } */
}

function easyrss_footer($html) {
    global $CONFIG,$lang_plugin_easyrss;
    require ('plugins/Easy_RSS/include/init.inc.php');

    if(($CONFIG['plugin_easyrss_showrss'] || $CONFIG['plugin_easyrss_showgoogle']) &&
                in_array($_SERVER[SCRIPT_NAME],array('index.php','thumbnails.php','displayimage.php'))) {
        global $CONFIG;
        $album=$_GET['album'];
        $cat=$_GET['cat'];

	if(isset($cat) && $cat < 10000)
	    return $html;

	$feed = str_replace("http://","",$CONFIG[ecards_more_pic_target])."rss.php";
        if($album)
            $feed .= "?album=".$album;
        if($cat)
            if($cat > 10000)
    	    $feed .= "?album=lastupby&uid=".($cat-10000);
    	else
                $feed .= "?cat=".$cat;
    
        $html .= "<center>\n";

	if($CONFIG['plugin_easyrss_showrss']) {
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
	    $rss_ico = '<a href="http://'.$feed.'">';
	    $rss_ico .= '<img src="plugins/Easy_RSS/rss.gif" border=0 alt="'.$lang_plugin_easyrss['alt_rss_feed'].'"></a>';
	    $html .= "$rss_ico\n";
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
	}
	
	if($CONFIG['plugin_easyrss_showgoogle']) {
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
            $goog_ico = '<a href="http://fusion.google.com/add?feedurl=';
	    $goog_ico .= 'http%3A//'.$feed;
            $goog_ico .= '"><img src="http://buttons.googlesyndication.com/fusion/add.gif" width="104" height="17" border="0" alt="'.$lang_plugin_easyrss['alt_google'].'"></a>';
	    $html .= "$goog_ico\n";
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
	}
	
	if($CONFIG['plugin_easyrss_showyahoo']) {
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
	    $name = "";
	    if(is_numeric($album)) {
	        $name = get_album_name($album);
	        $name = $CONFIG[gallery_name]. " - " . $name['title'];
	    } else if(isset($cat) && $cat > 0) {
		if($cat<10000) {
		    $name = easyrss_get_cat_name($cat);
		    $name = $CONFIG[gallery_name]. " - " . $name['name'];
		} else {
		    $name = $CONFIG[gallery_name]. " - " . get_username($cat-10000);
		}
	    } else
	        $name = $CONFIG[gallery_name];
    
	    $yahoo_ico = '<a href="http://us.rd.yahoo.com/my/atm/';
	    $yahoo_ico .= $CONFIG[gallery_name] . '/';
	    $yahoo_ico .= $name;
	    $yahoo_ico .= '/*http://add.my.yahoo.com/rss?url=http%3A//';
	    $yahoo_ico .= $feed;
	    $yahoo_ico .= '"><img src="http://us.i1.yimg.com/us.yimg.com/i/us/my/addtomyyahoo4.gif" width="91" height="17" border="0" alt="'.$lang_plugin_easyrss['alt_yahoo'].'"></a>';
	    $html .= "$yahoo_ico\n";
	    $html .= '<img src="images/spacer.gif" border=0 width=12 height=17>';
	}
	
	$html .= "</center>\n";
    }

    return $html;
}

function easyrss_get_cat_name($cid)
{
        global $CONFIG;
        global $lang_errors;

        $result = cpg_db_query("SELECT name from {$CONFIG['TABLE_CATEGORIES']} WHERE cid='$cid'");
        $count = mysql_num_rows($result);
        if ($count > 0) {
                $row = mysql_fetch_array($result);
                return $row;
        } else {
                cpg_die(ERROR, $lang_errors['non_exist_ap'], __FILE__, __LINE__);
        }
}

function piclens_thumbView($pics){
		for($i = 0; $i < count($pics); $i++){
			$pics[$i]['caption_text'] = "<span class=\"mbf-item\">#gallery ".(md5($pics[$i]['pid']))."</span>".$pics[$i]['caption_text'];

		}
		return $pics;
	}
	
?>
